package ex1;

class A 
{ 
	public A() 
	{ }
}

class B extends A 
{
	public B() 
	{ 
		super();
	}

	public String toString() 
	{
		/*
		 * Appel a la méthode de la classe parent: A
		 * N'étant pas définie dans A ce sera
		 * la méthode toString définie 
		 * dans la closse Object qui sera executée
		 * Cette méthode dans Object renvoie
		 * un String donnant le nom de la classe de l'objet
		 * suivi d'un '@' et d'un numéro identifiant l'objet.
		 * Cette méthode renverra donc par exemple la chaine: "Hello ex1.B@38503429"
		 * si l'objet coourant est de classe B.
		 */
		return(" Hello " + super.toString());
	}
}
public class TestAB 
{
	public TestAB() 
	{
		A a = new B();
		/* appelle la méthode toString de l'objet a
		* l'objet a étant une instance de la classe B
		* c'est la méthode de la classe B qui sera exécutée
		*/
		System.out.println(a);
	}
	public static void main(String[] args) 
	{
		TestAB tAB = new TestAB();
	}
}